﻿EnableExplicit

Enumeration File
  #SourceFile
  #DestFile
EndEnumeration

Macro IsHex(Char)
  (('0' <= Char And Char <= '9') Or ('A' <= Char And Char <= 'F'))
EndMacro

; --------------------------------------------------------------------------------------------------------------------------------------------
; Main loop
; --------------------------------------------------------------------------------------------------------------------------------------------

Define.i iProgramParametersNum, iFileLength, iStrLen, *iBinFile, iStrIndex, iBinIndex, iMSNibble, iLSNibble, iWrittenBytes
Define.s sSourceFileName, sDestFileName, sString;, sDirectory, sWorkingDirectory, sCliCommand, sTrash, sFileName

iProgramParametersNum = CountProgramParameters()
If iProgramParametersNum
  sSourceFileName = ProgramParameter(0)
  If ReadFile(#SourceFile, sSourceFileName)
    sDestFileName = sSourceFileName + ".bin"
;     Debug "sDestFileName = '" + sDestFileName + "'"
    If ReadFile(#DestFile, sDestFileName, #PB_File_NoBuffering)
      CloseFile(#DestFile)
      MessageRequester("Warning !", "File '" + sDestFileName + "'already exist !" + Chr(10) + 
                 "Change Source File Name or Delete Dest File", #PB_MessageRequester_Warning|#PB_MessageRequester_Ok)
    Else
      iFileLength = Lof(#SourceFile)
      If iFileLength
;         Debug "File Length: " + Str(iFileLength)
        *iBinFile = AllocateMemory(iFileLength / 2)
        If *iBinFile
          If CreateFile(#DestFile, sDestFileName, #PB_Ascii)
            iBinIndex = 0
            While Not(Eof(#SourceFile))
              sString = UCase(ReadString(#SourceFile, #PB_Ascii))
              iStrLen = Len(sString)
              iStrIndex = 1
              While iStrIndex < iStrLen
                iMSNibble = Asc(Mid(sString, iStrIndex, 1))
                iLSNibble = Asc(Mid(sString, iStrIndex + 1, 1))
                If IsHex(iMSNibble)
                  If IsHex(iLSNibble) ; Hex Nibbles must come as a pair !
                    PokeB(*iBinFile + iBinIndex, Val("$" + Mid(sString, iStrIndex, 2)))
                    iBinIndex = iBinIndex + 1
;                     ShowMemoryViewer(*iBinFile, iFileLength / 2)
                  EndIf
                  iStrIndex = iStrIndex + 2 ; Point to the next Byte anyway
                Else
                  iStrIndex = iStrIndex + 1
                EndIf
              Wend
            Wend
            iWrittenBytes = WriteData(#DestFile, *iBinFile, iBinIndex)
            If iWrittenBytes <> iBinIndex
              MessageRequester("Error", "WriteData Error !" + Chr(10) + 
                 "iWrittenBytes = '" + iWrittenBytes + "'; iBinIndex = '" + iBinIndex + "'", #PB_MessageRequester_Error)
            Else
              MessageRequester("Information", "File '" + sDestFileName + "' successfully created !")
            EndIf
            CloseFile(#DestFile)
          Else
            MessageRequester("Warning", "Can't create Destination File !", #PB_MessageRequester_Warning)
          EndIf
          FreeMemory(*iBinFile)
        Else
          MessageRequester("Warning", "Memory Allocation Error !", #PB_MessageRequester_Warning)
        EndIf
      Else
        MessageRequester("Warning", "Source File is empty !", #PB_MessageRequester_Warning)
      EndIf
    EndIf
  CloseFile(#SourceFile)
  Else
    MessageRequester("Warning", "Can't open '" + sSourceFileName + "' !", #PB_MessageRequester_Warning)
  EndIf
EndIf
End

; IDE Options = PureBasic 5.71 LTS (Windows - x64)
; ExecutableFormat = Console
; CursorPosition = 60
; FirstLine = 20
; Folding = -
; Markers = 8
; EnableXP
; Executable = Text2Bin.exe
; CommandLine = "M:\Archive H\Vintage computing\6502\Junior Computer\bootstrap junior\Edition dump bootstrap junior computer.bin - Copie.txt"
; CompileSourceDirectory